# Change Log

All notable changes to this project will be documented in this file. See [standard-version](https://github.com/conventional-changelog/standard-version) for commit guidelines.

<a name="1.0.0"></a>
# 1.0.0 (2018-11-09)


### Bug Fixes

* dependency setup ([c722a3e](https://github.com/medikoo/dev-package-install/commit/c722a3e))
* do not follow in case of not confirmed dev package ([102de35](https://github.com/medikoo/dev-package-install/commit/102de35))
* do not install on spot non semver install ([3699ead](https://github.com/medikoo/dev-package-install/commit/3699ead))
* ensure to clean progress on error exit ([20d006c](https://github.com/medikoo/dev-package-install/commit/20d006c))
* fix handling of optional dev packages ([3e0674f](https://github.com/medikoo/dev-package-install/commit/3e0674f))
* getPackageJson error handling ([10ecb9a](https://github.com/medikoo/dev-package-install/commit/10ecb9a))
* handling of optional dependencies ([9b2b093](https://github.com/medikoo/dev-package-install/commit/9b2b093))
* isValidSymlink handling ([770a939](https://github.com/medikoo/dev-package-install/commit/770a939))
* npm link setup ([8a3044a](https://github.com/medikoo/dev-package-install/commit/8a3044a))
* npm modules path ([ccd2c78](https://github.com/medikoo/dev-package-install/commit/ccd2c78))
* recognize `update` command in cli help ([3239e84](https://github.com/medikoo/dev-package-install/commit/3239e84))
* revert mistakenly commented out code ([7458650](https://github.com/medikoo/dev-package-install/commit/7458650))
* **cli:** --no-pull  arg resolution ([61cd13a](https://github.com/medikoo/dev-package-install/commit/61cd13a))
* symlink path check ([72b113a](https://github.com/medikoo/dev-package-install/commit/72b113a))
* update meta after version upgrade ([0e5fd56](https://github.com/medikoo/dev-package-install/commit/0e5fd56))
* update of linked external dependency ([fc0af8f](https://github.com/medikoo/dev-package-install/commit/fc0af8f))


### Features

* cli progress ([bfe041c](https://github.com/medikoo/dev-package-install/commit/bfe041c))
* differentiate between install and update operation ([d70afc8](https://github.com/medikoo/dev-package-install/commit/d70afc8))
* drop singleton nature ([a138b2e](https://github.com/medikoo/dev-package-install/commit/a138b2e))
* enable git push option ([08a7d11](https://github.com/medikoo/dev-package-install/commit/08a7d11))
* ensure npm link error to be fully exposed ([52e5137](https://github.com/medikoo/dev-package-install/commit/52e5137))
* ensure npm link points package at path ([f99b650](https://github.com/medikoo/dev-package-install/commit/f99b650))
* ensure to cleanup after npm crash ([6a84450](https://github.com/medikoo/dev-package-install/commit/6a84450))
* ensure to link dependency if link is not rigth ([796ce85](https://github.com/medikoo/dev-package-install/commit/796ce85))
* general install command ([b8dcbc1](https://github.com/medikoo/dev-package-install/commit/b8dcbc1))
* handle gently no packageJson case ([07a9adc](https://github.com/medikoo/dev-package-install/commit/07a9adc))
* host user specific configuration externally ([439abb1](https://github.com/medikoo/dev-package-install/commit/439abb1))
* ignore npm error if link was created ([c0dba47](https://github.com/medikoo/dev-package-install/commit/c0dba47))
* improve error message ([3ef6633](https://github.com/medikoo/dev-package-install/commit/3ef6633))
* improve error reporting ([05d6c6c](https://github.com/medikoo/dev-package-install/commit/05d6c6c))
* improve log message ([eb5acf0](https://github.com/medikoo/dev-package-install/commit/eb5acf0))
* improve logging ([2acf1c3](https://github.com/medikoo/dev-package-install/commit/2acf1c3))
* improve logging ([3b053f8](https://github.com/medikoo/dev-package-install/commit/3b053f8))
* improve npm error handling ([41f14a7](https://github.com/medikoo/dev-package-install/commit/41f14a7))
* improve repo update logic ([fca33a9](https://github.com/medikoo/dev-package-install/commit/fca33a9))
* improve warning message ([d63030c](https://github.com/medikoo/dev-package-install/commit/d63030c))
* inform of install type ([05a98ac](https://github.com/medikoo/dev-package-install/commit/05a98ac))
* inform on whether repository was created ([0602ab5](https://github.com/medikoo/dev-package-install/commit/0602ab5))
* introduce non dependency cleanup step ([51afdbc](https://github.com/medikoo/dev-package-install/commit/51afdbc))
* log error in case linked version mismatch version range ([df533f8](https://github.com/medikoo/dev-package-install/commit/df533f8))
* make options optional ([324d9da](https://github.com/medikoo/dev-package-install/commit/324d9da))
* make setupRepository public ([240dfea](https://github.com/medikoo/dev-package-install/commit/240dfea))
* mark end after pending jobs are finalized ([f492985](https://github.com/medikoo/dev-package-install/commit/f492985))
* new approach for linking/installing externals ([8eeef09](https://github.com/medikoo/dev-package-install/commit/8eeef09))
* new version ([40056aa](https://github.com/medikoo/dev-package-install/commit/40056aa))
* pass options to hook ([74503a4](https://github.com/medikoo/dev-package-install/commit/74503a4))
* put logs at hidden level, expose emitter ([a2b2d33](https://github.com/medikoo/dev-package-install/commit/a2b2d33))
* remove support for mirror 'update' command ([124ae32](https://github.com/medikoo/dev-package-install/commit/124ae32))
* rename main module to installPackage ([77e3b5e](https://github.com/medikoo/dev-package-install/commit/77e3b5e))
* rename skipGitUpdate to disableGitPull ([3aa6806](https://github.com/medikoo/dev-package-install/commit/3aa6806))
* seclude getPackageJson ([16e3126](https://github.com/medikoo/dev-package-install/commit/16e3126))
* simplify CLI args ([520d979](https://github.com/medikoo/dev-package-install/commit/520d979))
* simplify option names ([03b056a](https://github.com/medikoo/dev-package-install/commit/03b056a))
* **bin:** commands support in binary ([5117688](https://github.com/medikoo/dev-package-install/commit/5117688))
* **cli:** improve usage message ([2b7884d](https://github.com/medikoo/dev-package-install/commit/2b7884d))
* simplify skipGitUpdate handling ([0343807](https://github.com/medikoo/dev-package-install/commit/0343807))
* solidify npm modules path resolution ([9094fd5](https://github.com/medikoo/dev-package-install/commit/9094fd5))
* support recovery from any npm link error ([dd453d0](https://github.com/medikoo/dev-package-install/commit/dd453d0))
* support skipNestedGitUpdate option ([1fe3351](https://github.com/medikoo/dev-package-install/commit/1fe3351))
* support update command ([351a592](https://github.com/medikoo/dev-package-install/commit/351a592))
* update-all command ([39773c9](https://github.com/medikoo/dev-package-install/commit/39773c9))
* upgrade external when higher version is discovered ([4fe8591](https://github.com/medikoo/dev-package-install/commit/4fe8591))
